// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) 2008-2009 Universite catholique de Louvain
//
// See the Copyright.txt and License.txt files for license information. 
// You should have received a copy of these files along with MAdLib. 
// If not, see <http://www.madlib.be/license/>
//
// Please report all bugs and problems to <contrib@madlib.be>
//
// Authors: Gaetan Compere, Jean-Francois Remacle
// -------------------------------------------------------------------

#ifndef _H_MADOUTPUT
#define _H_MADOUTPUT

#include "SizeFieldBase.h"
#include "MSops.h"

#include <string>
#include <set>

namespace MAd {

  // -------------------------------------------------------------------
  typedef enum MAdOutputData {
    OD_CONSTANT,
    OD_MEANRATIO,
    OD_ISOSIZEFIELD,
    OD_DIMENSION,
    OD_ITERORDER  // for debugging
  } MAdOutputData;

  // -------------------------------------------------------------------

  void MAdGmshOutput(const pMesh m, const pSField sf, 
                     const char *fn, MAdOutputData type);

  void MAdAttachedNodalDataOutput   (const pMesh m, const char *fn, 
                                     pMeshDataId id);
  void MAdAttachedNodalDataVecOutput(const pMesh m, const char *fn, 
                                     pMeshDataId id);

  void printPosEntities(const pPList ents, std::string fn, MAdOutputData type, 
                        const pSField sf=NULL, int id=0);

  void printPosRegions(const std::set<pRegion>, std::string fn, MAdOutputData type, 
                       const pSField sf=NULL, int id=0);

  // -------------------------------------------------------------------

}

#endif
