// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) 2008-2009 Universite catholique de Louvain
//
// See the Copyright.txt and License.txt files for license information. 
// You should have received a copy of these files along with MAdLib. 
// If not, see <http://www.madlib.be/license/>
//
// Please report all bugs and problems to <contrib@madlib.be>
//
// Authors: Gaetan Compere, Jean-Francois Remacle
// -------------------------------------------------------------------

#ifndef _H_MATHUTILS
#define _H_MATHUTILS

namespace MAd {

  // -------------------------------------------------------------------
  // --- Vectors ---

  void   diffVec      (const double [3], const double [3], double [3]);
  double dotProd      (const double [3], const double [3]);
  void   crossProd    (const double [3], const double [3], double [3]);
  void   normalizeVec (const double [3], double[3]);
  void   printVec     (const double [3], const char * name="");

  // -------------------------------------------------------------------
  // --- Matrices ---

  void   transpMat    (const double [3][3], double [3][3]);
  double detMat       (const double [3][3]);
  double traceMat     (const double [3][3]);
  double traceMatMat  (const double [3][3]);
  void   vecMat       (const double [3],    const double [3][3], double [3]);
  void   matVec       (const double [3][3], const double [3],    double [3]);
  double vecMatVec    (const double [3][3], const double [3]);
  void   matMat       (const double [3][3], const double [3][3], double [3][3]);
  double inverseMat   (const double [3][3], double [3][3]);
  bool   system       (const double [3][3], const double [3], double [3], double *);
  void   printMat     (const double [3][3], const char * name="");

  // -------------------------------------------------------------------

  void sort(double [3]);
  void cubicRoots(const double [4], double [3], double [3]);
  int indexOfMin(double, double, double);
  int indexOfMax(double, double, double);
  void pointToPlane(const double [3][3], const double [3], double[3]);
  double distanceSq(const double[3], const double[3]);

  // -------------------------------------------------------------------

}

#endif
